/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>



#define VER         "0.1.1"
#define KEYPATH     "Software\\Master Gekus\\Gekus & Igori Mail Checker\\Accounts\\Account %03d"
#define BUFFSZ      8192



int readreg(HKEY key, u_char *buff, u_char *value);
void gim_pwd(u_char *pwd);



int main(void) {
    HKEY    key;
    u_char  keybuff[BUFFSZ],
            value[BUFFSZ];
    int     i;


    setbuf(stdout, NULL);

    fputs("\n"
        "Gekus & Igori Mail Checker passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    for(i = 0; i < 1000; i++) {
        sprintf(keybuff, KEYPATH, i);

        if(RegOpenKeyEx(HKEY_CURRENT_USER, keybuff, 0, KEY_READ, &key)) break;

        if(readreg(key, value, "Name") < 0) break;
        printf("\nAccount:    %s\n", value);

        if(readreg(key, value, "Server") < 0) break;
        printf("Server:     %s:", value);

        if(readreg(key, value, "Port") < 0) break;
        printf("%d\n", *(int *)value);

        if(readreg(key, value, "User") < 0) break;
        printf("Username:   %s\n", value);

        if(readreg(key, value, "Password") < 0) break;
        gim_pwd(value);
        printf("Password:   %s\n", value);

        RegCloseKey(key);
    }

    if(!i) {
        fputs("\nNo registry keys found\n", stdout);
    }

    fputs("\n\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



int readreg(HKEY key, u_char *buff, u_char *value) {
    int valuelen = BUFFSZ;

    if(RegQueryValueEx(
        key,
        value,
        NULL,
        NULL,
        buff,
        (void *)&valuelen)) return(-1);
    return(0);
}



void gim_pwd(u_char *pwd) {
    u_char  *tmpbuff,
            *out,
            *ptr,
            al,
            bl,
            cl,
            dl;
    int     i,
            tmp,
            len;

    len = 0;
    out = pwd;
    while(1) {
        pwd++;
        ptr = strchr(pwd, '.');
        sscanf(pwd, "%d", &tmp);
        pwd = ptr;
        out[len] = tmp;
        len++;
        if(!ptr) break;
    }

    al = 1;
    pwd = out + len - 1;
    i = len = len >> 1;

    tmpbuff = malloc(len);
    if(!tmpbuff) return;
    ptr = tmpbuff;

    while(i--) {
        bl = cl = *pwd--;
        cl >>= 1;
        bl &= al;
        dl = cl;
        dl &= al;
        bl <<= 1;
        cl >>= 1;
        dl |= bl;
        bl = cl & al;
        dl <<= 1;
        cl >>= 1;
        bl |= dl;
        dl = cl & al;
        bl <<= 1;
        cl >>= 1;
        dl |= bl;
        bl = cl & al;
        dl <<= 1;
        cl >>= 1;
        bl |= dl;
        dl = cl & al;
        bl <<= 1;
        cl >>= 1;
        dl |= bl;
        bl = cl & al;
        bl = bl | (dl << 1);
        cl = (cl >> 1) & al;
        cl = cl | (bl << 1);
        *ptr++ = cl;
    }
    ptr = tmpbuff;
    while(len--) {
        *out ^= *ptr;
        out++;
        ptr++;
    }
    *out = 0;
    free(tmpbuff);
}

